//+------------------------------------------------------------------+
//|                                                  My MACD Sample.mq4 |
//|                   Copyright 2005-2014, MetaQuotes Software Corp. |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright   "2005-2014, MetaQuotes Software Corp."
#property link        "http://www.mql4.com"

extern double Lots =0.1;

int MAGIC_NUMBER = 20170711;
double slippage = 10;
int longOrder, shortOrder;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick(void)
  {
   double MacdCurrent,MacdPrevious;
   double SignalCurrent,SignalPrevious;
   int    total;
//---
   if(Bars<100)
     {
      Print("Bars less than 100, RETURN.");
      return;
     }
     
//--- to simplify the coding and speed up access data are put into internal variables
   MacdCurrent=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   SignalCurrent=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPrevious=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);

   bool longSignal = MacdCurrent>SignalCurrent && MacdPrevious<SignalPrevious;
   bool shortSignal = MacdCurrent<SignalCurrent && MacdPrevious>SignalPrevious;
   
   //---
   total=OrdersTotal();
   if(longSignal)
     {
//---     
      if(total < 1)
        {
         //--- go long   
         longOrder = OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"macd sample",MAGIC_NUMBER,0,Green);
        }
      else
        {
         //--- close short position
         for(int i=0;i<total;i++)
           {
            if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
               continue; // continue till is's true
            if(OrderType() == OP_SELL && OrderMagicNumber() == MAGIC_NUMBER && OrderSymbol() == Symbol())
              {
               //--- close order and exit
               if(!OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Yellow))
                  Print("OrderClose error ",GetLastError());
               return;
              }
           }
        }        
//---        
     }
   if(shortSignal)
     {
//---     
      if(total < 1)
        {
         //--- go short   
//         longOrder = OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"macd sample",MAGIC_NUMBER,0,Green);
        }
      else
        {
         //--- close long position
         for(i=0;i<total;i++)
           {
            if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
               continue; // continue till is's true
            if(OrderType() == OP_BUY && OrderMagicNumber() == MAGIC_NUMBER && OrderSymbol() == Symbol())
              {
               //--- close order and exit
               if(!OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Yellow))
                  Print("OrderClose error ",GetLastError());
               return;
              }
           }
        }        
//---        
     }     
   //---
   
//---
  }
//+------------------------------------------------------------------+
